<?php

/**
 * Really basic sort handler for sorting Solr documents in Views.
 */
class SarniaViewsHandlerSort extends SearchApiViewsHandlerSort {

  public function option_definition() {
    $options = parent::option_definition();
    $options['solr_property'] = array('default' => NULL);
    return $options;
  }

  public function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    $form['solr_property'] = array(
      '#type' => 'select',
      '#title' => t('Solr property'),
      '#options' => sarnia_index_get_options($this->definition['search_api_index'], 'getSortFields'),
      '#default_value' => $this->options['solr_property'],
    );
    sarnia_element_add_combobox($form['solr_property']);
  }

  public function query() {
    $this->real_field = $this->options['solr_property'];
    parent::query();
  }

  public function admin_summary() {
    $summary = parent::admin_summary();
    return check_plain($this->options['solr_property']) . ', ' . $summary;
  }

}
