<?php

/**
 * Implements hook_field_views_data().
 */
function sarnia_field_views_data($field) {
  $data = array();

  $field_name = $field['field_name'];
  foreach (array_keys($field['bundles']) as $type_name) {
    if ($entity_type = sarnia_entity_type_load($type_name)) {
      $key = 'search_api_index_' . $entity_type['search_api_index'];
      $instance = field_info_instance($type_name, $field_name, $type_name);

      $data[$key]['table']['base']['defaults']['field'] = 'id';
      $data[$key][$field_name] = array(
        'title' => 'Solr property',
        'help' => t('Properties from the Apache Solr core used by the Search API server %server', array('%server' => $entity_type['search_api_server'])),
        'search_api_index' => $entity_type['search_api_index'],
        'argument' => array(
          'handler' => 'SarniaViewsHandlerArgument',
          'field_name' => $field_name,
          'search_api_index' => $entity_type['search_api_index'],
        ),
        'field' => array(
          'handler' => 'SarniaViewsHandlerField',
          'field_name' => $field_name,
          'search_api_index' => $entity_type['search_api_index'],
        ),
        'filter' => array(
          'handler' => 'SarniaViewsHandlerFilter',
          'field_name' => $field_name,
          'search_api_index' => $entity_type['search_api_index'],
        ),
        'sort' => array(
          'handler' => 'SarniaViewsHandlerSort',
          'field_name' => $field_name,
          'search_api_index' => $entity_type['search_api_index'],
        ),
      );
      $data[$key]['sarnia_entity'] = array(
        'title' => 'Entity',
        'help' => t('A fully rendered Sarnia entity.'),
        'search_api_index' => $entity_type['search_api_index'],
        'real field' => 'entity',
        'field' => array(
          'handler' => 'SarniaViewsHandlerFieldEntity',
          'field_name' => $field_name,
          'search_api_index' => $entity_type['search_api_index'],
        ),
      );
    }
  }

  return $data;
}
